/* util-js.c generated by valac 0.38.10, the Vala compiler
 * generated from util-js.vala, do not modify */

/*
 * Copyright 2017 Michael James Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <JavaScriptCore/JavaScript.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <gobject/gvaluecollector.h>

#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define GEARY_JS_TYPE_CALLABLE (geary_js_callable_get_type ())
#define GEARY_JS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_JS_TYPE_CALLABLE, GearyJSCallable))
#define GEARY_JS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_JS_TYPE_CALLABLE, GearyJSCallableClass))
#define GEARY_JS_IS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_JS_TYPE_CALLABLE))
#define GEARY_JS_IS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_JS_TYPE_CALLABLE))
#define GEARY_JS_CALLABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_JS_TYPE_CALLABLE, GearyJSCallableClass))

typedef struct _GearyJSCallable GearyJSCallable;
typedef struct _GearyJSCallableClass GearyJSCallableClass;
typedef struct _GearyJSCallablePrivate GearyJSCallablePrivate;
typedef struct _GearyJSParamSpecCallable GearyJSParamSpecCallable;

/**
     * Errors produced by functions in {@link Geary.JS}.
     */
typedef enum  {
	GEARY_JS_ERROR_EXCEPTION,
	GEARY_JS_ERROR_TYPE
} GearyJSError;
#define GEARY_JS_ERROR geary_js_error_quark ()
struct _GearyJSCallable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GearyJSCallablePrivate * priv;
};

struct _GearyJSCallableClass {
	GTypeClass parent_class;
	void (*finalize) (GearyJSCallable *self);
};

struct _GearyJSCallablePrivate {
	gchar* base_name;
	gchar** safe_args;
	gint safe_args_length1;
	gint _safe_args_size_;
};

struct _GearyJSParamSpecCallable {
	GParamSpec parent_instance;
};


static gpointer geary_js_callable_parent_class = NULL;

GQuark geary_js_error_quark (void);
gboolean geary_js_is_null (JSContextRef context, JSValueRef* js);
gdouble geary_js_to_number (JSContextRef context, JSValueRef value, GError** error);
static JSValueRef* _JS_value_dup (JSValueRef* self);
void geary_js_check_exception (JSContextRef context, JSValueRef* err_value, GError** error);
gchar* geary_js_to_string (JSContextRef context, JSValueRef value, GError** error);
gchar* geary_js_to_string_released (JSStringRef js);
JSObjectRef* geary_js_to_object (JSContextRef context, JSValueRef value, GError** error);
static JSObjectRef* _JS_object_dup (JSObjectRef* self);
JSValueRef* geary_js_get_property (JSContextRef context, JSObjectRef object, const gchar* name, GError** error);
const gchar* JS_type_to_string (JSType self);
static const char* _JS_type_to_string (JSType value);
gchar* geary_js_escape_string (const gchar* value);
gpointer geary_js_callable_ref (gpointer instance);
void geary_js_callable_unref (gpointer instance);
GParamSpec* geary_js_param_spec_callable (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void geary_js_value_set_callable (GValue* value, gpointer v_object);
void geary_js_value_take_callable (GValue* value, gpointer v_object);
gpointer geary_js_value_get_callable (const GValue* value);
GType geary_js_callable_get_type (void) G_GNUC_CONST;
GearyJSCallable* geary_js_callable (const gchar* base_name);
GearyJSCallable* geary_js_callable_new (const gchar* base_name);
GearyJSCallable* geary_js_callable_construct (GType object_type, const gchar* base_name);
#define GEARY_JS_CALLABLE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GEARY_JS_TYPE_CALLABLE, GearyJSCallablePrivate))
gchar* geary_js_callable_to_string (GearyJSCallable* self);
GearyJSCallable* geary_js_callable_string (GearyJSCallable* self, const gchar* value);
static inline void geary_js_callable_add_param (GearyJSCallable* self, const gchar* value);
GearyJSCallable* geary_js_callable_double (GearyJSCallable* self, gdouble value);
GearyJSCallable* geary_js_callable_int (GearyJSCallable* self, gint value);
GearyJSCallable* geary_js_callable_bool (GearyJSCallable* self, gboolean value);
static void _vala_array_add23 (gchar** * array, int* length, int* size, gchar* value);
static void geary_js_callable_finalize (GearyJSCallable * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GQuark geary_js_error_quark (void) {
	return g_quark_from_static_string ("geary_js_error-quark");
}


/**
     * Determines if a {@link JS.Value} object is {{{null}}}.
     *
     * @return `true` if `js` is `null` or has a {@link JS.Type} of
     * `NULL` according to `context`.
     */
inline gboolean geary_js_is_null (JSContextRef context, JSValueRef* js) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	JSValueRef* _tmp1_;
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = js;
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (_tmp1_ == NULL) {
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp0_ = TRUE;
#line 126 "util-js.c"
	} else {
		JSValueRef* _tmp2_;
		JSContextRef _tmp3_;
		JSType _tmp4_;
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp2_ = js;
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp3_ = context;
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp4_ = JSValueGetType (_tmp3_, *_tmp2_);
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp0_ = _tmp4_ == kJSTypeNull;
#line 139 "util-js.c"
	}
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 145 "util-js.c"
}


/**
     * Returns a JSC Value as a number.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `Number`.
     */
static JSValueRef* _JS_value_dup (JSValueRef* self) {
	JSValueRef* dup;
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	dup = g_new0 (JSValueRef, 1);
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	memcpy (dup, self, sizeof (JSValueRef));
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return dup;
#line 163 "util-js.c"
}


static gpointer __JS_value_dup0 (gpointer self) {
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return self ? _JS_value_dup (self) : NULL;
#line 170 "util-js.c"
}


gdouble geary_js_to_number (JSContextRef context, JSValueRef value, GError** error) {
	gdouble result = 0.0;
	JSContextRef _tmp0_;
	gboolean _tmp1_;
	JSValueRef* err = NULL;
	gdouble number = 0.0;
	JSContextRef _tmp5_;
	JSValueRef _tmp6_ = {0};
	gdouble _tmp7_;
	JSValueRef _tmp8_;
	JSValueRef* _tmp9_;
	JSContextRef _tmp10_;
	JSValueRef* _tmp11_;
	GError * _inner_error_ = NULL;
#line 48 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = context;
#line 48 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = JSValueIsNumber (_tmp0_, value);
#line 48 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (!_tmp1_) {
#line 194 "util-js.c"
		GError* _tmp2_;
#line 49 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp2_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS Number object");
#line 49 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_inner_error_ = _tmp2_;
#line 49 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 202 "util-js.c"
			gdouble _tmp3_ = 0.0;
#line 49 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 49 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return _tmp3_;
#line 208 "util-js.c"
		} else {
			gdouble _tmp4_ = 0.0;
#line 49 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 49 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 49 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return _tmp4_;
#line 217 "util-js.c"
		}
	}
#line 52 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = NULL;
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp5_ = context;
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp7_ = JSValueToNumber (_tmp5_, value, &_tmp6_);
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp8_ = _tmp6_;
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp9_ = __JS_value_dup0 (&_tmp8_);
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = _tmp9_;
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	number = _tmp7_;
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp10_ = context;
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp11_ = err;
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_check_exception (_tmp10_, _tmp11_, &_inner_error_);
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 246 "util-js.c"
			gdouble _tmp12_ = 0.0;
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return _tmp12_;
#line 254 "util-js.c"
		} else {
			gdouble _tmp13_ = 0.0;
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return _tmp13_;
#line 265 "util-js.c"
		}
	}
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = number;
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 274 "util-js.c"
}


/**
     * Returns a JSC Value as a string.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `String`.
     */
gchar* geary_js_to_string (JSContextRef context, JSValueRef value, GError** error) {
	gchar* result = NULL;
	JSContextRef _tmp0_;
	gboolean _tmp1_;
	JSValueRef* err = NULL;
	JSStringRef js_str = {0};
	JSContextRef _tmp3_;
	JSValueRef _tmp4_ = {0};
	JSStringRef _tmp5_;
	JSValueRef _tmp6_;
	JSValueRef* _tmp7_;
	JSContextRef _tmp8_;
	JSValueRef* _tmp9_;
	gchar* _tmp10_;
	GError * _inner_error_ = NULL;
#line 67 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = context;
#line 67 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = JSValueIsString (_tmp0_, value);
#line 67 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (!_tmp1_) {
#line 305 "util-js.c"
		GError* _tmp2_;
#line 68 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp2_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS String object");
#line 68 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_inner_error_ = _tmp2_;
#line 68 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 68 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 68 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 317 "util-js.c"
		} else {
#line 68 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 68 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 68 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 325 "util-js.c"
		}
	}
#line 71 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = NULL;
#line 72 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = context;
#line 72 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp5_ = JSValueToStringCopy (_tmp3_, value, &_tmp4_);
#line 72 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 72 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp6_ = _tmp4_;
#line 72 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp7_ = __JS_value_dup0 (&_tmp6_);
#line 72 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = _tmp7_;
#line 72 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	js_str = _tmp5_;
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp8_ = context;
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp9_ = err;
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_check_exception (_tmp8_, _tmp9_, &_inner_error_);
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 360 "util-js.c"
		} else {
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 370 "util-js.c"
		}
	}
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp10_ = geary_js_to_string_released (js_str);
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp10_;
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 381 "util-js.c"
}


/**
     * Returns a JSC Value as an object.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `Object`.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
static JSObjectRef* _JS_object_dup (JSObjectRef* self) {
	JSObjectRef* dup;
#line 98 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	dup = g_new0 (JSObjectRef, 1);
#line 98 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	memcpy (dup, self, sizeof (JSObjectRef));
#line 98 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return dup;
#line 402 "util-js.c"
}


static gpointer __JS_object_dup0 (gpointer self) {
#line 98 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return self ? _JS_object_dup (self) : NULL;
#line 409 "util-js.c"
}


JSObjectRef* geary_js_to_object (JSContextRef context, JSValueRef value, GError** error) {
	JSObjectRef* result = NULL;
	JSContextRef _tmp0_;
	gboolean _tmp1_;
	JSValueRef* err = NULL;
	JSObjectRef js_obj = {0};
	JSContextRef _tmp3_;
	JSValueRef _tmp4_ = {0};
	JSObjectRef _tmp5_;
	JSValueRef _tmp6_;
	JSValueRef* _tmp7_;
	JSContextRef _tmp8_;
	JSValueRef* _tmp9_;
	JSObjectRef* _tmp10_;
	GError * _inner_error_ = NULL;
#line 90 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = context;
#line 90 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = JSValueIsObject (_tmp0_, value);
#line 90 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (!_tmp1_) {
#line 434 "util-js.c"
		GError* _tmp2_;
#line 91 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp2_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS Object");
#line 91 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_inner_error_ = _tmp2_;
#line 91 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 91 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 91 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 446 "util-js.c"
		} else {
#line 91 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 91 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 91 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 454 "util-js.c"
		}
	}
#line 94 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = NULL;
#line 95 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = context;
#line 95 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp5_ = JSValueToObject (_tmp3_, value, &_tmp4_);
#line 95 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 95 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp6_ = _tmp4_;
#line 95 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp7_ = __JS_value_dup0 (&_tmp6_);
#line 95 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = _tmp7_;
#line 95 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	js_obj = _tmp5_;
#line 96 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp8_ = context;
#line 96 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp9_ = err;
#line 96 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_check_exception (_tmp8_, _tmp9_, &_inner_error_);
#line 96 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 96 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 96 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 96 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 96 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 489 "util-js.c"
		} else {
#line 96 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 96 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 96 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 96 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 499 "util-js.c"
		}
	}
#line 98 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp10_ = __JS_object_dup0 (&js_obj);
#line 98 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp10_;
#line 98 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 98 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 510 "util-js.c"
}


/**
     * Returns a JSC {@link JS.String} as a Vala {@link string}.
     */
inline gchar* geary_js_to_string_released (JSStringRef js) {
	gchar* result = NULL;
	gint len = 0;
	gint _tmp0_;
	gchar* str = NULL;
	gchar* _tmp1_;
#line 105 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = JSStringGetMaximumUTF8CStringSize (js);
#line 105 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	len = _tmp0_;
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = g_strnfill ((gsize) len, (gchar) 0);
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	str = _tmp1_;
#line 107 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	JSStringGetUTF8CString (js, str, len);
#line 108 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	JSStringRelease (js);
#line 109 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = str;
#line 109 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 539 "util-js.c"
}


/**
     * Returns the value of an object's property.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * object does not contain the named property.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
inline JSValueRef* geary_js_get_property (JSContextRef context, JSObjectRef object, const gchar* name, GError** error) {
	JSValueRef* result = NULL;
	JSStringRef js_name = {0};
	const gchar* _tmp0_;
	JSStringRef _tmp1_;
	JSValueRef* err = NULL;
	JSValueRef prop = {0};
	JSContextRef _tmp2_;
	JSStringRef _tmp3_;
	JSValueRef* _tmp4_ = NULL;
	JSValueRef _tmp5_;
	JSValueRef* _tmp8_;
	GError * _inner_error_ = NULL;
#line 121 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 125 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = name;
#line 125 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = JSStringCreateWithUTF8CString (_tmp0_);
#line 125 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	js_name = _tmp1_;
#line 126 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = NULL;
#line 127 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = context;
#line 127 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = js_name;
#line 127 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp5_ = JSObjectGetProperty (_tmp2_, object, _tmp3_, &_tmp4_);
#line 127 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 127 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = _tmp4_;
#line 127 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	prop = _tmp5_;
#line 587 "util-js.c"
	{
		JSContextRef _tmp6_;
		JSValueRef* _tmp7_;
#line 129 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp6_ = context;
#line 129 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp7_ = err;
#line 129 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		geary_js_check_exception (_tmp6_, _tmp7_, &_inner_error_);
#line 129 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 599 "util-js.c"
			goto __finally319;
		}
	}
	__finally319:
	{
#line 131 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		JSStringRelease (js_name);
#line 607 "util-js.c"
	}
#line 128 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 128 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 128 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 128 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 128 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 619 "util-js.c"
		} else {
#line 128 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 128 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 128 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 128 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 629 "util-js.c"
		}
	}
#line 133 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp8_ = __JS_value_dup0 (&prop);
#line 133 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp8_;
#line 133 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 133 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 640 "util-js.c"
}


/**
     * Checks an JS exception returned from a JSC call.
     *
     * This method will raise a {@link Geary.JS.Error} if the given
     * `err_value` is not null (in a Vala or JS sense).
     */
static const char* _JS_type_to_string (JSType value) {
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	switch (value) {
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		case kJSTypeUndefined:
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return "kJSTypeUndefined";
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		case kJSTypeNull:
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return "kJSTypeNull";
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		case kJSTypeBoolean:
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return "kJSTypeBoolean";
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		case kJSTypeNumber:
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return "kJSTypeNumber";
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		case kJSTypeString:
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return "kJSTypeString";
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		case kJSTypeObject:
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return "kJSTypeObject";
#line 677 "util-js.c"
	}
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return NULL;
#line 681 "util-js.c"
}


inline void geary_js_check_exception (JSContextRef context, JSValueRef* err_value, GError** error) {
	JSContextRef _tmp0_;
	JSValueRef* _tmp1_;
	gboolean _tmp2_;
	GError * _inner_error_ = NULL;
#line 145 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = context;
#line 145 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = err_value;
#line 145 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = geary_js_is_null (_tmp0_, _tmp1_);
#line 145 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (!_tmp2_) {
#line 698 "util-js.c"
		JSValueRef* nested_err = NULL;
		JSType err_type = 0;
		JSValueRef* _tmp3_;
		JSContextRef _tmp4_;
		JSType _tmp5_;
		JSStringRef err_str = {0};
		JSValueRef* _tmp6_;
		JSContextRef _tmp7_;
		JSValueRef _tmp8_ = {0};
		JSStringRef _tmp9_;
		JSValueRef _tmp10_;
		JSValueRef* _tmp11_;
		JSContextRef _tmp12_;
		JSValueRef* _tmp13_;
		gboolean _tmp14_;
		JSType _tmp18_;
		const gchar* _tmp19_;
		JSStringRef _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GError* _tmp25_;
		GError* _tmp26_;
#line 146 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		nested_err = NULL;
#line 147 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp3_ = err_value;
#line 147 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp4_ = context;
#line 147 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp5_ = JSValueGetType (_tmp4_, *_tmp3_);
#line 147 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		err_type = _tmp5_;
#line 148 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp6_ = err_value;
#line 148 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp7_ = context;
#line 148 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp9_ = JSValueToStringCopy (_tmp7_, *_tmp6_, &_tmp8_);
#line 148 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_g_free0 (nested_err);
#line 148 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp10_ = _tmp8_;
#line 148 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp11_ = __JS_value_dup0 (&_tmp10_);
#line 148 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		nested_err = _tmp11_;
#line 148 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		err_str = _tmp9_;
#line 151 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp12_ = context;
#line 151 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp13_ = nested_err;
#line 151 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp14_ = geary_js_is_null (_tmp12_, _tmp13_);
#line 151 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (!_tmp14_) {
#line 757 "util-js.c"
			JSType _tmp15_;
			const gchar* _tmp16_;
			GError* _tmp17_;
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_tmp15_ = err_type;
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_tmp16_ = _JS_type_to_string (_tmp15_);
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_tmp17_ = g_error_new (GEARY_JS_ERROR, GEARY_JS_ERROR_EXCEPTION, "Nested exception getting exception %s as a string", _tmp16_);
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_inner_error_ = _tmp17_;
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				g_propagate_error (error, _inner_error_);
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_g_free0 (nested_err);
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				return;
#line 777 "util-js.c"
			} else {
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_g_free0 (nested_err);
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				g_clear_error (&_inner_error_);
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				return;
#line 787 "util-js.c"
			}
		}
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp18_ = err_type;
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp19_ = _JS_type_to_string (_tmp18_);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp20_ = err_str;
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp21_ = geary_js_to_string_released (_tmp20_);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp22_ = _tmp21_;
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp23_ = g_strdup_printf ("JS exception thrown [%s]: %s", _tmp19_, _tmp22_);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp24_ = _tmp23_;
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp25_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_EXCEPTION, _tmp24_);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp26_ = _tmp25_;
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_g_free0 (_tmp24_);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_g_free0 (_tmp22_);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_inner_error_ = _tmp26_;
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_g_free0 (nested_err);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return;
#line 822 "util-js.c"
		} else {
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_g_free0 (nested_err);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return;
#line 832 "util-js.c"
		}
#line 145 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_g_free0 (nested_err);
#line 836 "util-js.c"
	}
}


/**
     * Escapes a string so as to be safe to use as a JS string literal.
     *
     * This does not append opening or closing quotes.
     */
static gboolean string_valid_char (const gchar* self, gint index) {
	gboolean result = FALSE;
	guint8 c = 0U;
	gint _tmp0_;
	guint8 _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	guint8 _tmp4_;
#line 1124 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1125 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1125 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = ((guint8*) self)[_tmp0_];
#line 1125 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	c = _tmp1_;
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp4_ = c;
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (((gint) _tmp4_) == 0x00) {
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp3_ = TRUE;
#line 868 "util-js.c"
	} else {
		gboolean _tmp5_ = FALSE;
		guint8 _tmp6_;
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp6_ = c;
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (((gint) _tmp6_) >= 0x80) {
#line 876 "util-js.c"
			guint8 _tmp7_;
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_tmp7_ = c;
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_tmp5_ = ((gint) _tmp7_) < 0xc2;
#line 882 "util-js.c"
		} else {
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 886 "util-js.c"
		}
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp3_ = _tmp5_;
#line 890 "util-js.c"
	}
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp2_ = TRUE;
#line 896 "util-js.c"
	} else {
		guint8 _tmp8_;
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = c;
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp2_ = ((gint) _tmp8_) >= 0xf5;
#line 903 "util-js.c"
	}
#line 1126 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp2_) {
#line 1127 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = FALSE;
#line 1127 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 911 "util-js.c"
	} else {
#line 1129 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = TRUE;
#line 1129 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 917 "util-js.c"
	}
}


static gunichar string_get_char (const gchar* self, glong index) {
	gunichar result = 0U;
	glong _tmp0_;
	gunichar _tmp1_;
#line 1148 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1149 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1149 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
#line 1149 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1149 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 936 "util-js.c"
}


static guint8* g_string_get_data (GString* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	gssize _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
#line 4886 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 4887 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = self->str;
#line 4887 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	res = (guint8*) _tmp0_;
#line 4887 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	res_length1 = -1;
#line 4887 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_res_size_ = res_length1;
#line 4888 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = self->len;
#line 4888 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 4888 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 4889 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp3_ = res;
#line 4889 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 4889 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 4889 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 4889 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (result_length1) {
#line 4889 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 980 "util-js.c"
	}
#line 4889 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 4889 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 986 "util-js.c"
}


gchar* geary_js_escape_string (const gchar* value) {
	gchar* result = NULL;
	GString* builder = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GString* _tmp3_;
	GString* _tmp29_;
	guint8* _tmp30_;
	gint _tmp30__length1;
	guint8* _tmp31_;
	gint _tmp31__length1;
	gchar* _tmp32_;
#line 170 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 171 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = value;
#line 171 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = strlen (_tmp0_);
#line 171 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = _tmp1_;
#line 171 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = g_string_sized_new ((gsize) _tmp2_);
#line 171 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	builder = _tmp3_;
#line 1015 "util-js.c"
	{
		gint i = 0;
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		i = 0;
#line 1020 "util-js.c"
		{
			gboolean _tmp4_ = FALSE;
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_tmp4_ = TRUE;
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			while (TRUE) {
#line 1027 "util-js.c"
				gint _tmp6_;
				const gchar* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				const gchar* _tmp10_;
				gint _tmp11_;
				gboolean _tmp12_;
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				if (!_tmp4_) {
#line 1037 "util-js.c"
					gint _tmp5_;
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					_tmp5_ = i;
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					i = _tmp5_ + 1;
#line 1043 "util-js.c"
				}
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp4_ = FALSE;
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp6_ = i;
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp7_ = value;
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp8_ = strlen (_tmp7_);
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp9_ = _tmp8_;
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				if (!(_tmp6_ < _tmp9_)) {
#line 172 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					break;
#line 1059 "util-js.c"
				}
#line 173 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp10_ = value;
#line 173 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp11_ = i;
#line 173 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp12_ = string_valid_char (_tmp10_, _tmp11_);
#line 173 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				if (_tmp12_) {
#line 1069 "util-js.c"
					gunichar c = 0U;
					const gchar* _tmp13_;
					gint _tmp14_;
					gunichar _tmp15_;
					gunichar _tmp16_;
#line 174 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					_tmp13_ = value;
#line 174 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					_tmp14_ = i;
#line 174 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					_tmp15_ = string_get_char (_tmp13_, (glong) _tmp14_);
#line 174 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					c = _tmp15_;
#line 175 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					_tmp16_ = c;
#line 175 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					switch (_tmp16_) {
#line 175 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\x00':
#line 1089 "util-js.c"
						{
							GString* _tmp17_;
#line 177 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp17_ = builder;
#line 177 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp17_, "\x00");
#line 178 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1098 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\'':
#line 1102 "util-js.c"
						{
							GString* _tmp18_;
#line 180 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp18_ = builder;
#line 180 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp18_, "\\'");
#line 181 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1111 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '"':
#line 1115 "util-js.c"
						{
							GString* _tmp19_;
#line 183 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp19_ = builder;
#line 183 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp19_, "\\\"");
#line 184 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1124 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\\':
#line 1128 "util-js.c"
						{
							GString* _tmp20_;
#line 186 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp20_ = builder;
#line 186 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp20_, "\\\\");
#line 187 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1137 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\n':
#line 1141 "util-js.c"
						{
							GString* _tmp21_;
#line 189 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp21_ = builder;
#line 189 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp21_, "\\n");
#line 190 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1150 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\r':
#line 1154 "util-js.c"
						{
							GString* _tmp22_;
#line 192 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp22_ = builder;
#line 192 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp22_, "\\r");
#line 193 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1163 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\x0b':
#line 1167 "util-js.c"
						{
							GString* _tmp23_;
#line 195 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp23_ = builder;
#line 195 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp23_, "\x0b");
#line 196 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1176 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\t':
#line 1180 "util-js.c"
						{
							GString* _tmp24_;
#line 198 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp24_ = builder;
#line 198 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp24_, "\\t");
#line 199 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1189 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\b':
#line 1193 "util-js.c"
						{
							GString* _tmp25_;
#line 201 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp25_ = builder;
#line 201 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp25_, "\\b");
#line 202 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1202 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\f':
#line 1206 "util-js.c"
						{
							GString* _tmp26_;
#line 204 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp26_ = builder;
#line 204 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp26_, "\\f");
#line 205 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1215 "util-js.c"
						}
						default:
						{
							GString* _tmp27_;
							gunichar _tmp28_;
#line 207 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp27_ = builder;
#line 207 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp28_ = c;
#line 207 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append_unichar (_tmp27_, _tmp28_);
#line 208 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1229 "util-js.c"
						}
					}
				}
			}
		}
	}
#line 212 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp29_ = builder;
#line 212 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp30_ = g_string_get_data (_tmp29_, &_tmp30__length1);
#line 212 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp31_ = _tmp30_;
#line 212 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp31__length1 = _tmp30__length1;
#line 212 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp32_ = g_strdup ((const gchar*) _tmp31_);
#line 212 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp32_;
#line 212 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_string_free0 (builder);
#line 212 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1252 "util-js.c"
}


/**
     * Convenience method for returning a new Callable instance.
     */
GearyJSCallable* geary_js_callable (const gchar* base_name) {
	GearyJSCallable* result = NULL;
	const gchar* _tmp0_;
	GearyJSCallable* _tmp1_;
#line 218 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (base_name != NULL, NULL);
#line 219 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = base_name;
#line 219 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = geary_js_callable_new (_tmp0_);
#line 219 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp1_;
#line 219 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1273 "util-js.c"
}


GearyJSCallable* geary_js_callable_construct (GType object_type, const gchar* base_name) {
	GearyJSCallable* self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 231 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (base_name != NULL, NULL);
#line 231 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self = (GearyJSCallable*) g_type_create_instance (object_type);
#line 232 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = base_name;
#line 232 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 232 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (self->priv->base_name);
#line 232 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->priv->base_name = _tmp1_;
#line 231 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return self;
#line 1295 "util-js.c"
}


GearyJSCallable* geary_js_callable_new (const gchar* base_name) {
#line 231 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return geary_js_callable_construct (GEARY_JS_TYPE_CALLABLE, base_name);
#line 1302 "util-js.c"
}


static gchar* _vala_g_strjoinv (const gchar* separator, gchar** str_array, int str_array_length1) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 1086 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = separator;
#line 1086 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp0_ == NULL) {
#line 1087 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		separator = "";
#line 1318 "util-js.c"
	}
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp2_ = str_array;
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp2__length1 = str_array_length1;
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp2_ != NULL) {
#line 1326 "util-js.c"
		gboolean _tmp3_ = FALSE;
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = str_array;
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4__length1 = str_array_length1;
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (_tmp4__length1 > 0) {
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_tmp3_ = TRUE;
#line 1338 "util-js.c"
		} else {
			gboolean _tmp5_ = FALSE;
			gchar** _tmp6_;
			gint _tmp6__length1;
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_tmp6_ = str_array;
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_tmp6__length1 = str_array_length1;
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_tmp6__length1 == -1) {
#line 1349 "util-js.c"
				gchar** _tmp7_;
				gint _tmp7__length1;
				const gchar* _tmp8_;
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp7_ = str_array;
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp7__length1 = str_array_length1;
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp8_ = _tmp7_[0];
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp5_ = _tmp8_ != NULL;
#line 1361 "util-js.c"
			} else {
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp5_ = FALSE;
#line 1365 "util-js.c"
			}
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_tmp3_ = _tmp5_;
#line 1369 "util-js.c"
		}
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = _tmp3_;
#line 1373 "util-js.c"
	} else {
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = FALSE;
#line 1377 "util-js.c"
	}
#line 1089 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1381 "util-js.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp31_;
		gint _tmp33_;
		gint _tmp34_;
		gsize _tmp35_;
		const gchar* _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
		gint _tmp39_;
		const gchar* res = NULL;
		gsize _tmp40_;
		void* _tmp41_;
		void* ptr = NULL;
		const gchar* _tmp42_;
		gchar** _tmp43_;
		gint _tmp43__length1;
		const gchar* _tmp44_;
		void* _tmp45_;
		const gchar* _tmp62_;
#line 1091 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		len = (gsize) 1;
#line 1404 "util-js.c"
		{
			gboolean _tmp9_ = FALSE;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			i = 0;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_tmp9_ = TRUE;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			while (TRUE) {
#line 1413 "util-js.c"
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gchar** _tmp13_;
				gint _tmp13__length1;
				gint _tmp21_ = 0;
				gchar** _tmp22_;
				gint _tmp22__length1;
				gint _tmp23_;
				const gchar* _tmp24_;
				gsize _tmp30_;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				if (!_tmp9_) {
#line 1426 "util-js.c"
					gint _tmp10_;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp10_ = i;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					i = _tmp10_ + 1;
#line 1432 "util-js.c"
				}
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp9_ = FALSE;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp13_ = str_array;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp13__length1 = str_array_length1;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				if (_tmp13__length1 != -1) {
#line 1442 "util-js.c"
					gint _tmp14_;
					gchar** _tmp15_;
					gint _tmp15__length1;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp14_ = i;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp15_ = str_array;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp15__length1 = str_array_length1;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp12_ = _tmp14_ < _tmp15__length1;
#line 1454 "util-js.c"
				} else {
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp12_ = FALSE;
#line 1458 "util-js.c"
				}
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				if (_tmp12_) {
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp11_ = TRUE;
#line 1464 "util-js.c"
				} else {
					gboolean _tmp16_ = FALSE;
					gchar** _tmp17_;
					gint _tmp17__length1;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp17_ = str_array;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp17__length1 = str_array_length1;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					if (_tmp17__length1 == -1) {
#line 1475 "util-js.c"
						gchar** _tmp18_;
						gint _tmp18__length1;
						gint _tmp19_;
						const gchar* _tmp20_;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
						_tmp18_ = str_array;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
						_tmp18__length1 = str_array_length1;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
						_tmp19_ = i;
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
						_tmp20_ = _tmp18_[_tmp19_];
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
						_tmp16_ = _tmp20_ != NULL;
#line 1490 "util-js.c"
					} else {
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
						_tmp16_ = FALSE;
#line 1494 "util-js.c"
					}
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp11_ = _tmp16_;
#line 1498 "util-js.c"
				}
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				if (!_tmp11_) {
#line 1092 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					break;
#line 1504 "util-js.c"
				}
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp22_ = str_array;
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp22__length1 = str_array_length1;
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp23_ = i;
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp24_ = _tmp22_[_tmp23_];
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				if (_tmp24_ != NULL) {
#line 1516 "util-js.c"
					gchar** _tmp25_;
					gint _tmp25__length1;
					gint _tmp26_;
					const gchar* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp25_ = str_array;
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp25__length1 = str_array_length1;
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp26_ = i;
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp27_ = _tmp25_[_tmp26_];
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp28_ = strlen ((const gchar*) _tmp27_);
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp29_ = _tmp28_;
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp21_ = _tmp29_;
#line 1537 "util-js.c"
				} else {
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp21_ = 0;
#line 1541 "util-js.c"
				}
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp30_ = len;
#line 1093 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				len = _tmp30_ + _tmp21_;
#line 1547 "util-js.c"
			}
		}
#line 1095 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp31_ = i;
#line 1095 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (_tmp31_ == 0) {
#line 1554 "util-js.c"
			gchar* _tmp32_;
#line 1096 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_tmp32_ = g_strdup ("");
#line 1096 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			result = _tmp32_;
#line 1096 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return result;
#line 1562 "util-js.c"
		}
#line 1098 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp33_ = i;
#line 1098 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		str_array_length1 = _tmp33_;
#line 1098 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp34_ = str_array_length1;
#line 1099 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp35_ = len;
#line 1099 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp36_ = separator;
#line 1099 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp37_ = strlen ((const gchar*) _tmp36_);
#line 1099 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp38_ = _tmp37_;
#line 1099 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp39_ = i;
#line 1099 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		len = _tmp35_ + (_tmp38_ * (_tmp39_ - 1));
#line 1101 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp40_ = len;
#line 1101 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp41_ = g_malloc (_tmp40_);
#line 1101 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		res = _tmp41_;
#line 1102 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp42_ = res;
#line 1102 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp43_ = str_array;
#line 1102 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp43__length1 = str_array_length1;
#line 1102 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp44_ = _tmp43_[0];
#line 1102 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp45_ = g_stpcpy ((void*) _tmp42_, (const gchar*) _tmp44_);
#line 1102 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		ptr = _tmp45_;
#line 1600 "util-js.c"
		{
			gboolean _tmp46_ = FALSE;
#line 1103 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			i = 1;
#line 1103 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_tmp46_ = TRUE;
#line 1103 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			while (TRUE) {
#line 1609 "util-js.c"
				gint _tmp48_;
				gchar** _tmp49_;
				gint _tmp49__length1;
				void* _tmp50_;
				const gchar* _tmp51_;
				void* _tmp52_;
				const gchar* _tmp53_ = NULL;
				gchar** _tmp54_;
				gint _tmp54__length1;
				gint _tmp55_;
				const gchar* _tmp56_;
				void* _tmp60_;
				void* _tmp61_;
#line 1103 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				if (!_tmp46_) {
#line 1625 "util-js.c"
					gint _tmp47_;
#line 1103 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp47_ = i;
#line 1103 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					i = _tmp47_ + 1;
#line 1631 "util-js.c"
				}
#line 1103 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp46_ = FALSE;
#line 1103 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp48_ = i;
#line 1103 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp49_ = str_array;
#line 1103 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp49__length1 = str_array_length1;
#line 1103 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				if (!(_tmp48_ < _tmp49__length1)) {
#line 1103 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					break;
#line 1645 "util-js.c"
				}
#line 1104 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp50_ = ptr;
#line 1104 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp51_ = separator;
#line 1104 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp52_ = g_stpcpy (_tmp50_, (const gchar*) _tmp51_);
#line 1104 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				ptr = _tmp52_;
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp54_ = str_array;
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp54__length1 = str_array_length1;
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp55_ = i;
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp56_ = _tmp54_[_tmp55_];
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				if (_tmp56_ != NULL) {
#line 1665 "util-js.c"
					gchar** _tmp57_;
					gint _tmp57__length1;
					gint _tmp58_;
					const gchar* _tmp59_;
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp57_ = str_array;
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp57__length1 = str_array_length1;
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp58_ = i;
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp59_ = _tmp57_[_tmp58_];
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp53_ = (const gchar*) _tmp59_;
#line 1680 "util-js.c"
				} else {
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
					_tmp53_ = "";
#line 1684 "util-js.c"
				}
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp60_ = ptr;
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				_tmp61_ = g_stpcpy (_tmp60_, _tmp53_);
#line 1105 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
				ptr = _tmp61_;
#line 1692 "util-js.c"
			}
		}
#line 1108 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp62_ = res;
#line 1108 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		res = NULL;
#line 1108 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = (gchar*) _tmp62_;
#line 1108 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 1703 "util-js.c"
	} else {
		gchar* _tmp63_;
#line 1110 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp63_ = g_strdup ("");
#line 1110 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp63_;
#line 1110 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 1712 "util-js.c"
	}
}


gchar* geary_js_callable_to_string (GearyJSCallable* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = self->priv->base_name;
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = g_strconcat (_tmp0_, "(", NULL);
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = _tmp1_;
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = self->priv->safe_args;
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3__length1 = self->priv->safe_args_length1;
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp4_ = _vala_g_strjoinv (",", _tmp3_, _tmp3__length1);
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp5_ = _tmp4_;
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp7_ = _tmp6_;
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp8_ = g_strconcat (_tmp7_, ");", NULL);
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp9_ = _tmp8_;
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp7_);
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp5_);
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp2_);
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp9_;
#line 236 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1764 "util-js.c"
}


static gpointer _geary_js_callable_ref0 (gpointer self) {
#line 241 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return self ? geary_js_callable_ref (self) : NULL;
#line 1771 "util-js.c"
}


GearyJSCallable* geary_js_callable_string (GearyJSCallable* self, const gchar* value) {
	GearyJSCallable* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GearyJSCallable* _tmp7_;
#line 239 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 239 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 240 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = value;
#line 240 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = geary_js_escape_string (_tmp0_);
#line 240 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = _tmp1_;
#line 240 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = g_strconcat ("\"", _tmp2_, NULL);
#line 240 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp4_ = _tmp3_;
#line 240 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp5_ = g_strconcat (_tmp4_, "\"", NULL);
#line 240 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp6_ = _tmp5_;
#line 240 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp6_);
#line 240 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp6_);
#line 240 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp4_);
#line 240 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp2_);
#line 241 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp7_ = _geary_js_callable_ref0 (self);
#line 241 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp7_;
#line 241 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1817 "util-js.c"
}


static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 879 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 879 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 879 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 879 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
#line 879 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 879 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 879 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 879 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 879 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 1847 "util-js.c"
}


GearyJSCallable* geary_js_callable_double (GearyJSCallable* self, gdouble value) {
	GearyJSCallable* result = NULL;
	gdouble _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GearyJSCallable* _tmp3_;
#line 244 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 245 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = value;
#line 245 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = double_to_string (_tmp0_);
#line 245 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = _tmp1_;
#line 245 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp2_);
#line 245 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp2_);
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = _geary_js_callable_ref0 (self);
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp3_;
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1875 "util-js.c"
}


GearyJSCallable* geary_js_callable_int (GearyJSCallable* self, gint value) {
	GearyJSCallable* result = NULL;
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GearyJSCallable* _tmp3_;
#line 249 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = value;
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = _tmp1_;
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp2_);
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp2_);
#line 251 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = _geary_js_callable_ref0 (self);
#line 251 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp3_;
#line 251 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1903 "util-js.c"
}


GearyJSCallable* geary_js_callable_bool (GearyJSCallable* self, gboolean value) {
	GearyJSCallable* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	GearyJSCallable* _tmp2_;
#line 254 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 255 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = value;
#line 255 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (_tmp1_) {
#line 255 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp0_ = "true";
#line 1920 "util-js.c"
	} else {
#line 255 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp0_ = "false";
#line 1924 "util-js.c"
	}
#line 255 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp0_);
#line 256 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = _geary_js_callable_ref0 (self);
#line 256 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp2_;
#line 256 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1934 "util-js.c"
}


static void _vala_array_add23 (gchar** * array, int* length, int* size, gchar* value) {
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if ((*length) == (*size)) {
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1945 "util-js.c"
	}
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	(*array)[(*length)++] = value;
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	(*array)[*length] = NULL;
#line 1951 "util-js.c"
}


static inline void geary_js_callable_add_param (GearyJSCallable* self, const gchar* value) {
	gchar** _tmp0_;
	gint _tmp0__length1;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 259 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_if_fail (GEARY_JS_IS_CALLABLE (self));
#line 259 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_if_fail (value != NULL);
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = self->priv->safe_args;
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0__length1 = self->priv->safe_args_length1;
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = value;
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_vala_array_add23 (&self->priv->safe_args, &self->priv->safe_args_length1, &self->priv->_safe_args_size_, _tmp2_);
#line 1974 "util-js.c"
}


static void geary_js_value_callable_init (GValue* value) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	value->data[0].v_pointer = NULL;
#line 1981 "util-js.c"
}


static void geary_js_value_callable_free_value (GValue* value) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (value->data[0].v_pointer) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		geary_js_callable_unref (value->data[0].v_pointer);
#line 1990 "util-js.c"
	}
}


static void geary_js_value_callable_copy_value (const GValue* src_value, GValue* dest_value) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (src_value->data[0].v_pointer) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		dest_value->data[0].v_pointer = geary_js_callable_ref (src_value->data[0].v_pointer);
#line 2000 "util-js.c"
	} else {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2004 "util-js.c"
	}
}


static gpointer geary_js_value_callable_peek_pointer (const GValue* value) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return value->data[0].v_pointer;
#line 2012 "util-js.c"
}


static gchar* geary_js_value_callable_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (collect_values[0].v_pointer) {
#line 2019 "util-js.c"
		GearyJSCallable * object;
		object = collect_values[0].v_pointer;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (object->parent_instance.g_class == NULL) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2026 "util-js.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2030 "util-js.c"
		}
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		value->data[0].v_pointer = geary_js_callable_ref (object);
#line 2034 "util-js.c"
	} else {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 2038 "util-js.c"
	}
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return NULL;
#line 2042 "util-js.c"
}


static gchar* geary_js_value_callable_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GearyJSCallable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (!object_p) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2053 "util-js.c"
	}
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (!value->data[0].v_pointer) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		*object_p = NULL;
#line 2059 "util-js.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		*object_p = value->data[0].v_pointer;
#line 2063 "util-js.c"
	} else {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		*object_p = geary_js_callable_ref (value->data[0].v_pointer);
#line 2067 "util-js.c"
	}
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return NULL;
#line 2071 "util-js.c"
}


GParamSpec* geary_js_param_spec_callable (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GearyJSParamSpecCallable* spec;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GEARY_JS_TYPE_CALLABLE), NULL);
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return G_PARAM_SPEC (spec);
#line 2085 "util-js.c"
}


gpointer geary_js_value_get_callable (const GValue* value) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE), NULL);
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return value->data[0].v_pointer;
#line 2094 "util-js.c"
}


void geary_js_value_set_callable (GValue* value, gpointer v_object) {
	GearyJSCallable * old;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE));
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	old = value->data[0].v_pointer;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (v_object) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_JS_TYPE_CALLABLE));
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		value->data[0].v_pointer = v_object;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		geary_js_callable_ref (value->data[0].v_pointer);
#line 2114 "util-js.c"
	} else {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 2118 "util-js.c"
	}
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (old) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		geary_js_callable_unref (old);
#line 2124 "util-js.c"
	}
}


void geary_js_value_take_callable (GValue* value, gpointer v_object) {
	GearyJSCallable * old;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE));
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	old = value->data[0].v_pointer;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (v_object) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_JS_TYPE_CALLABLE));
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		value->data[0].v_pointer = v_object;
#line 2143 "util-js.c"
	} else {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 2147 "util-js.c"
	}
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (old) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		geary_js_callable_unref (old);
#line 2153 "util-js.c"
	}
}


static void geary_js_callable_class_init (GearyJSCallableClass * klass) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_callable_parent_class = g_type_class_peek_parent (klass);
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	((GearyJSCallableClass *) klass)->finalize = geary_js_callable_finalize;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_type_class_add_private (klass, sizeof (GearyJSCallablePrivate));
#line 2165 "util-js.c"
}


static void geary_js_callable_instance_init (GearyJSCallable * self) {
	gchar** _tmp0_;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->priv = GEARY_JS_CALLABLE_GET_PRIVATE (self);
#line 228 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 228 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->priv->safe_args = _tmp0_;
#line 228 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->priv->safe_args_length1 = 0;
#line 228 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->priv->_safe_args_size_ = self->priv->safe_args_length1;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->ref_count = 1;
#line 2183 "util-js.c"
}


static void geary_js_callable_finalize (GearyJSCallable * obj) {
	GearyJSCallable * self;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_JS_TYPE_CALLABLE, GearyJSCallable);
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_signal_handlers_destroy (self);
#line 227 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (self->priv->base_name);
#line 228 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->priv->safe_args = (_vala_array_free (self->priv->safe_args, self->priv->safe_args_length1, (GDestroyNotify) g_free), NULL);
#line 2197 "util-js.c"
}


/**
     * A class for constructing a well formed, safe, invokable JS call.
     */
GType geary_js_callable_get_type (void) {
	static volatile gsize geary_js_callable_type_id__volatile = 0;
	if (g_once_init_enter (&geary_js_callable_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { geary_js_value_callable_init, geary_js_value_callable_free_value, geary_js_value_callable_copy_value, geary_js_value_callable_peek_pointer, "p", geary_js_value_callable_collect_value, "p", geary_js_value_callable_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GearyJSCallableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_js_callable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyJSCallable), 0, (GInstanceInitFunc) geary_js_callable_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType geary_js_callable_type_id;
		geary_js_callable_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GearyJSCallable", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&geary_js_callable_type_id__volatile, geary_js_callable_type_id);
	}
	return geary_js_callable_type_id__volatile;
}


gpointer geary_js_callable_ref (gpointer instance) {
	GearyJSCallable * self;
	self = instance;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_atomic_int_inc (&self->ref_count);
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return instance;
#line 2225 "util-js.c"
}


void geary_js_callable_unref (gpointer instance) {
	GearyJSCallable * self;
	self = instance;
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		GEARY_JS_CALLABLE_GET_CLASS (self)->finalize (self);
#line 225 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2238 "util-js.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



